﻿using LaserBlasterTag.entities.lasers;
using LaserBlasterTag.scenes;
using Otter;
using System;

namespace LaserBlasterTag.entities
{
    public class Player : Entity
    {
        private Spritemap<string> _spriteMap;
        //private sound death = new Sound(Assets.SFX_DEATH); //todo
        private bool _hMove = true;
        private bool _vMove = true;
        public static bool canPlayerCollide = true;
        public static bool isSpritemapChanged = true;
        private BasicMovement Movement = new BasicMovement(200, 200, 200);

        public Player(float x, float y)
        {
            X = x; Y = y;
            SetHitbox(8, 16, (int)Global.Type.PLAYER);
            Collider.X = 20;
            Collider.Y = 20;
            Axis axis = Axis.CreateWASD();
            Movement.Axis = axis;
            Movement.Collider = Collider;
            Movement.AddCollision((int)Global.Type.SOLID);//walls
            Movement.AddCollision((int)Global.Type.BLUEPLAYER);
            Movement.AddCollision((int)Global.Type.REDPLAYER);
            Movement.AddCollision((int)Global.Type.REDBASE);
            Movement.AddCollision((int)Global.Type.BLUEBASE);
            AddComponents(axis, Movement);
            loadCorrectSpritemap();
            Global.PlayerSpeed = Movement.Speed;
        }

        public override void Update()
        {
            base.Update();
            #region Camera
            //if player is greater than the edge, greater than the other edge, less than the other edge, and less than the other edge, camera follows him.
            if (X > 220 && X < 1180)
                Scene.CameraX = X + 20 - Scene.HalfWidth;
            else if (X <= 220)
                Scene.CameraX = -480;
            else if (X >= 1180)
                Scene.CameraX = 480;
            if (Y > 110 && Y < 734)
                Scene.CameraY = Y + 50 - Scene.HalfHeight;
            else if (Y <= 110)
                Scene.CameraY = -320;
            else if (Y >= 304)
                Scene.CameraY = 304;
            //Scene.CenterCamera(X + 20, Y + 50);
            #endregion

            var cn = Global.PlayerSession.Controller;
            Global.PlayerX = this.X;
            Global.PlayerY = this.Y;
            Global.PlayerCurrentAnim = _spriteMap.CurrentAnim;
            if (cn.Button("R").Pressed)//testing!
            {
                Console.WriteLine("testing! R was pressed.");
                Console.WriteLine("x: " + X, "y: " + Y);
            }
            if (cn.Button("Up").Pressed)
                Scene.Add(new RedLaser(X + 23, Y + 29, "Up", this));//was 10, 22
            if (cn.Button("Right").Pressed)
                Scene.Add(new RedLaser(X + 27, Y + 26, "Right", this));//was 10, 22
            if (cn.Button("Left").Pressed)
                Scene.Add(new RedLaser(X + 19, Y + 26, "Left", this));//was 10, 22
            if (cn.Button("Down").Pressed)
                Scene.Add(new RedLaser(X + 23, Y + 33, "Down", this));//was 10, 22
            #region pressed Keys for animation
            if (cn.Button("A").Pressed || cn.Button("Left").Pressed)//LEFT
                _spriteMap.Play("walkLeft");
            else if (cn.Button("D").Pressed || cn.Button("Right").Pressed)//RIGHT
                _spriteMap.Play("walkRight");
            else if (cn.Button("W").Pressed || cn.Button("Up").Pressed)//UP
                _spriteMap.Play("walkUp");
            else if (cn.Button("S").Pressed || cn.Button("Down").Pressed)//DOWN
                _spriteMap.Play("walkDown");
            #endregion

            #region released keys for animation
            if (cn.Button("A").Released || cn.Button("Left").Released)//if i release left, updownright
            {
                if (cn.Button("W").Down || cn.Button("Up").Down)//and i'm holding up
                    _spriteMap.Play("walkUp");
                else if (cn.Button("S").Down || cn.Button("Down").Down)//and i'm holding down
                    _spriteMap.Play("walkDown");
                else if (cn.Button("D").Down || cn.Button("Right").Down)//and i'm holding right
                    _spriteMap.Play("walkRight");
            }
            else if (cn.Button("D").Released || cn.Button("Right").Released)//if i release right, updownleft
            {
                if (cn.Button("W").Down || cn.Button("Up").Down)//and i'm holding up
                    _spriteMap.Play("walkUp");
                else if (cn.Button("S").Down || cn.Button("Down").Down)//and i'm holding down
                    _spriteMap.Play("walkDown");
                else if (cn.Button("A").Down || cn.Button("Left").Down)//and i'm holding left
                    _spriteMap.Play("walkLeft");
            }
            else if (cn.Button("W").Released || cn.Button("Left").Released)//if i release up, rightleftdown
            {
                if (cn.Button("D").Down || cn.Button("Right").Down)//and i'm holding right
                    _spriteMap.Play("walkRight");
                else if (cn.Button("A").Down || cn.Button("Left").Down)//and i'm holding left
                    _spriteMap.Play("walkLeft");
                else if (cn.Button("S").Down || cn.Button("Down").Down)//and i'm holding down
                    _spriteMap.Play("walkDown");
            }
            else if (cn.Button("S").Released || cn.Button("Down").Released)//if i release down, rightleftup
            {
                if (cn.Button("D").Down || cn.Button("Right").Down)//and i'm holding right
                    _spriteMap.Play("walkRight");
                else if (cn.Button("A").Down || cn.Button("Left").Down)//and i'm holding left
                    _spriteMap.Play("walkLeft");
                else if (cn.Button("W").Down || cn.Button("Up").Down)//and i'm holding up
                    _spriteMap.Play("walkUp");
            }
            #endregion

            #region Hmovement or Vmovement
            if (cn.Button("A").Down)//LEFT
                _hMove = true;
            else if (cn.Button("D").Down)//RIGHT
                _hMove = true;
            else
                _hMove = false;
            if (cn.Button("W").Down)//UP
                _vMove = true;
            else if (cn.Button("S").Down)//DOWN
                _vMove = true;
            else
                _vMove = false;
            #endregion
            stopWalkingAnimations();
            #region Collisions
            #region CollideWithBlueLaser
            var collBlueLaser = Collider.Collide(X, Y, (int)Global.Type.BLUELASER);
            if (collBlueLaser != null)
            {
                BlueLaser r = (BlueLaser)collBlueLaser.Entity;
                r.destroy();
                Global.PlayerHealth--;
                _spriteMap.Play("hit");
            }
            if (Global.PlayerHealth <= 0)
            {
                destroy();
                Global.GAME.RemoveScene();
                Global.GAME.AddScene(new RedLoseScreen());
            }
            #endregion
            #endregion
            #region Death... is there death?
            #endregion
        }//END OF UPDATE
        public void loadCorrectSpritemap()
        {
            isSpritemapChanged = false;
            _spriteMap = null;
            _spriteMap = new Spritemap<string>(Assets.PLAYER, 46, 56);
            addNewSprites();
            _spriteMap.Update();
            _spriteMap.Play("standDown");
            Graphic = _spriteMap;
        }
        #region AddSprites
        public void addNewSprites()
        {
            var hMs = 8f;//horizontal animation speed
            var vMs = 8f;//vertical animation speed
            _spriteMap.Add("standRight", new int[] { 0 }, new float[] { hMs, hMs });
            _spriteMap.Add("standLeft", new int[] { 4 }, new float[] { hMs, hMs });
            _spriteMap.Add("standUp", new int[] { 2 }, new float[] { hMs, hMs });
            _spriteMap.Add("standDown", new int[] { 6 }, new float[] { hMs, hMs });
            _spriteMap.Add("walkRight", new int[] { 0, 1 }, new float[] { hMs, hMs });
            _spriteMap.Add("walkLeft", new int[] { 4, 5 }, new float[] { hMs, hMs });
            _spriteMap.Add("walkUp", new int[] { 2, 3 }, new float[] { vMs, vMs });
            _spriteMap.Add("walkDown", new int[] { 6, 7 }, new float[] { vMs, vMs });
            _spriteMap.Add("hit", new int[] { 8, 8, 8, 8 }, new float[] { vMs, vMs });
        }
        #endregion
        public void stopWalkingAnimations()
        {
            if (!_hMove && !_vMove)
            {
                switch (_spriteMap.CurrentAnim)
                {
                    case ("walkLeft"):
                        _spriteMap.Play("standLeft");
                        break;
                    case ("walkRight"):
                        _spriteMap.Play("standRight");
                        break;
                    case ("walkUp"):
                        _spriteMap.Play("standUp");
                        break;
                    case ("walkDown"):
                        _spriteMap.Play("standDown");
                        break;
                    default:
                        break;
                }
            }
        }

        public override void Render()//mainly for testing colliders :D
        {
            base.Render();
            //Collider.Render();
        }

        public void destroy()
        {
            RemoveSelf();
        }
    }
}
