﻿using Otter;
using System;

namespace LaserBlasterTag.entities.lasers
{
    class RedLaser : Entity
    {
        private int life = 200;
        private float _speed = 10.0f;//was 24.0f;
        private string _direction = "";
        Entity _e;
        public RedLaser(float x, float y, string direction, Entity e)
        {
            X = x; Y = y;
            _e = e;
            var image2 = Image.CreateCircle(2, Otter.Color.Red);
            var image = Image.CreateCircle(1, Otter.Color.White);
            SetHitbox(4, 4, (int)Global.Type.REDLASER);
            Collider.X = -2;
            Collider.Y = -2;
            _direction = direction;
            AddGraphic(image2);
            AddGraphic(image);
            image.CenterOrigin();
            image2.CenterOrigin();
        }
        public override void Update()
        {
            base.Update();
            if (life < 0)
                RemoveSelf();
            life--;
            if (_direction == "Right")
                X += _speed;
            else if (_direction == "Up")
                Y -= _speed;
            else if (_direction == "Left")
                X -= _speed;
            else if (_direction == "Down")
                Y += _speed;
            if (Collider.Collide(X, Y, (int)Global.Type.SOLID) != null)
                destroy();
        }
        public override void Render()
        {
            base.Render();
            if (_direction == "Right")
                Otter.Draw.Line(X, Y, _e.X + 27, _e.Y + 26, Otter.Color.Red);//this will need to follow the original direction of the shot.
            else if (_direction == "Up")
                Otter.Draw.Line(X, Y, _e.X + 23, _e.Y + 29, Otter.Color.Red);//this will need to follow the original direction of the shot.
            else if (_direction == "Left")
                Otter.Draw.Line(X, Y, _e.X + 19, _e.Y + 26, Otter.Color.Red);//this will need to follow the original direction of the shot.
            else if (_direction == "Down")
                Otter.Draw.Line(X, Y, _e.X + 23, _e.Y + 33, Otter.Color.Red);//this will need to follow the original direction of the shot.
        }
        public void destroy()
        {
            RemoveSelf();
        }
    }
}
