﻿using LaserBlasterTag.entities.lasers;
using LaserBlasterTag.scenes;
using Otter;

namespace LaserBlasterTag.entities.teams
{
    class BlueBase : Entity
    {
        private Spritemap<string> _spriteMap;
        private bool playOnce = true;
        private int _endGameTimer = 200;
        public BlueBase(float x, float y)
            : base(x, y)
        {
            SetHitbox(32, 32, (int)Global.Type.BLUEBASE);
            _spriteMap = new Spritemap<string>(Assets.BLUEBASE, 32, 32);
            addNewSprites();
            _spriteMap.Play("normal");
            Graphic = _spriteMap;
        }
        public override void Update()
        {
            base.Update();
            var collRedLaser = Collider.Collide(X, Y, (int)Global.Type.REDLASER);
            if (collRedLaser != null)
            {
                RedLaser r = (RedLaser)collRedLaser.Entity;
                r.destroy();
                playOnce = true;
                Global.BlueBaseHealth--;
            }
            if (Global.BlueBaseHealth == 4 && playOnce)
            {
                playOnce = false;
                _spriteMap.Play("hit1");
            }
            if (Global.BlueBaseHealth == 3 && playOnce)
            {
                playOnce = false;
                _spriteMap.Play("hit2");
            }
            if (Global.BlueBaseHealth == 2 && playOnce)
            {
                playOnce = false;
                _spriteMap.Play("hit3");
            }
            if (Global.BlueBaseHealth == 1 && playOnce)
            {
                playOnce = false;
                _spriteMap.Play("hit4");
            }
            if (Global.BlueBaseHealth == 0 && playOnce)
            {
                playOnce = false;
                _spriteMap.Play("death");
            }
            if (_spriteMap.CurrentAnim == "death" && _spriteMap.CurrentFrameIndex == 4)//is it 0 to frameindex?
                _spriteMap.Play("smoldering");
            if (_spriteMap.CurrentAnim == "smoldering")
                _endGameTimer--;
            if (_spriteMap.CurrentAnim == "smoldering" && _endGameTimer <= 0)
            {
                Global.GAME.RemoveScene();
                Global.GAME.AddScene(new RedWinScreen());
            }
        }
        public void addNewSprites()
        {
            var hMs = 10f;
            _spriteMap.Add("normal", new int[] { 0, 1 }, new float[] { hMs, hMs });
            _spriteMap.Add("hit1", new int[] { 0, 2 }, new float[] { hMs, hMs });
            _spriteMap.Add("hit2", new int[] { 0, 2, 3 }, new float[] { hMs, hMs });
            _spriteMap.Add("hit3", new int[] { 0, 3, 4 }, new float[] { hMs, hMs });
            _spriteMap.Add("hit4", new int[] { 0, 4, 5 }, new float[] { hMs, hMs });
            _spriteMap.Add("death", new int[] { 6, 7, 8, 9, 10 }, new float[] { 3f, 3f });
            _spriteMap.Add("smoldering", new int[] { 9, 10 }, new float[] { hMs, hMs });
        }

    }
}